const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const inventory_adjustments = sequelize.define(
    'inventory_adjustments',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

adjusted_at: {
        type: DataTypes.DATE,
      
      

      },

adjustment_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"sale",


"return",


"receiving",


"damage",


"correction",


"transfer"

        ],

      },

quantity_delta: {
        type: DataTypes.DECIMAL,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  inventory_adjustments.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

































//end loop



    db.inventory_adjustments.belongsTo(db.inventory_items, {
      as: 'inventory_item',
      foreignKey: {
        name: 'inventory_itemId',
      },
      constraints: false,
    });

    db.inventory_adjustments.belongsTo(db.users, {
      as: 'adjusted_by_user',
      foreignKey: {
        name: 'adjusted_by_userId',
      },
      constraints: false,
    });

    db.inventory_adjustments.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.inventory_adjustments.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.inventory_adjustments.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return inventory_adjustments;
};


